Subject: bug#36490: 26.1; directory-files-recursively breaks when it encounters a directory named "~"

From: Eli Zaretskii <[email-masked]>
Date: Tue, 09 Jul 2019 19:12:04 +0300

> From: Lars Ingebrigtsen <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Tue, 09 Jul 2019 17:50:49 +0200
> 
> > If you want "~" to be interpreted literally, you need to protect it
> > with "/:".
> 
> Sorry; I don't quite follow you here.  The doc string says that "~/" is
> interpreted specially.  There's no "/" in "~".  :-)

But it does NOT say that "~" will NOT be interpreted specially.

> That 
> 
> (expand-file-name "~/" "/tmp/")
> => "/home/larsi/"
> 
> is fine, because "~/" isn't a valid file name.  But "~" is, and that's
> the problem.

No, I think the problem is that the caller should have protected the
literal "~", as I said.